/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include "subnet.h"
#include "misc.h"

Subnet::Subnet()
{
	clear();
}

Subnet::~Subnet()
{
}

void Subnet::clear()
{
	int i;

	strcpy(name, "");
	ip.clear();
	gateway.clear();
	mask = 0;
	find = 0;
}

void Subnet::save(FILE *f)
{
	int i;

	for (i=0; i<64; i++)  fputc(name[i], f);
	gateway.save(f);
	ip.save(f);
	write_int(f, mask);
}

void Subnet::load(FILE *f)
{
	int i;

	for (i=0; i<64; i++) name[i] = fgetc(f); name[64] = '\0';
	gateway.load(f);
	ip.load(f);
	mask = read_int(f);
}

void Subnet::print()
{
	printf("Subnet name %s, ", name);
	gateway.print();
	printf(", ");
	ip.print();
	printf(" / %d\n", mask);
}

void Subnet::match(char *string)
{
	char nm[256], tmpnm[256];

	find = 0;
	if (strlen(string)==0) return;

	ip.sprint(tmpnm);
	sprintf(nm, "%s / %d", tmpnm, mask);
	if ((strlen(name)>0) && (lower_contains(name, string))) find = 1; else
	if (lower_contains(nm, string)) find = 2;
}

